/*
 * cnqtest.c	
 *
 * code: SASANO Takayoshi
 * --- public domain, no warranty.
 */

#include <basic.h>
#include <bstdio.h>
#include <bstdlib.h>
#include <errcode.h>
#include <tcode.h>
#include <tstring.h>
#include <btron/btron.h>
#include "clk.h"

#define	FIDVID_CTL	0xc0010041
#define	FIDVID_STATUS	0xc0010042

/* If you don't need current CPU frequency information, set DISP_FREQ as 0. */
#define	DISP_FREQ	1

LOCAL	ERR	readmsr(W dd, UW index, UW *edx, UW *eax)
{
	ERR	err;
	W	size;
	UW	buf[3];

	buf[0] = index;
	err = rea_dev(dd, 0, (VP)buf, sizeof(buf), &size, NULL);

	*eax = buf[1];
	*edx = buf[2];

	return err;
}

LOCAL	ERR	writemsr(W dd, UW index, UW edx, UW eax)
{
	ERR	err;
	W	size;
	UW	buf[3];

	buf[0] = index;
	buf[1] = eax;
	buf[2] = edx;
	err = wri_dev(dd, 0, (VP)buf, sizeof(buf), &size, NULL);

	return err;
}

EXPORT	ERR	main(W ac, TC *av[])
{
	WERR	err;
	W	i, dd, fid, vid;
	UW	eax, edx;
	TC	devname[] = {TK_c, TK_p, TK_u, TK_m, TK_s, TK_r, TK_NULL};

	err = opn_dev(devname, D_UPDATE | D_EXCL, NULL);
	if(err < ER_OK) {
		printf("opn_dev() %d\n", err);
		goto fin0;
	}
	dd = (W)err;

	for (i = 0; i < 2; i++) {
		err = readmsr(dd, FIDVID_STATUS, &edx, &eax);
		if (err < ER_OK) {
			printf("readmsr(FIDVID_STATUS) %d\n", err);
			goto fin1;
		}	
		printf("FIDVID_STATUS:\t%08x:%08x\n", edx, eax);

		if (ac < 2 || i) break;

		fid = tc_atoi(av[1]) & 0x1f;
		vid = edx & 0x1f;

		err = readmsr(dd, FIDVID_CTL, &edx, &eax);
		if (err < ER_OK) {
			printf("readmsr(FIDVID_CTL) %d\n", err);
			goto fin1;
		}

		eax = (1 << 16) | (vid << 8) | fid;
		printf("FIDVID_CTL:\t%08x:%08x\n", edx, eax);

		err = writemsr(dd, FIDVID_CTL, edx, eax);

		if (err < ER_OK) {
			printf("writemsr(FIDVID_CTL) %d\n", err);
			goto fin1;
		}
	}

#if	DISP_FREQ
	disp_freq();
#endif

 fin1:
	cls_dev(dd, 0, NULL);
 fin0:
	return err;
}
